#include <iostream>
#include <winsock.h>   //sitas dirba su soketais, portais ir t.t.
#include <vector>
using namespace std;


struct knygute        //kaip ir dinaminis sarasas
{
char uzrasas[256];   //charu masyvas, nes stringus nelabai eina siust per tinkla
knygute* kitas;
};


int perziureti(SOCKET soketas, knygute* &knygele)           //procedura, kuri perziuri uzrasus knyguteje
{
if (knygele->kitas != NULL)              //tiesiog eina per sarasa
   {
   knygute* knygele2;
   knygele2=knygele->kitas;
   while (knygele2->kitas!=NULL)
         {
         if (send(soketas, knygele2->uzrasas, 256, 0) != 256)  //ir siuncia klientui uzrasus
             {   //((soketas, ka siusti, kokio ilgio, nezinau) != ilgis)
             cout << "Nepavyko nusiusti duomenu." << endl; //jeigu ilgiai nesutampa, tai reiskia ivyko tinklo klaida
             return 1;  //returnu daug pridejau, kad veliau susekciau ar ivyko klaida, ar ne
             }
         knygele2=knygele2->kitas;
         }
   if (send(soketas, knygele2->uzrasas, 256, 0) != 256)
             {
             cout << "Nepavyko nusiusti duomenu." << endl;
             return 1;
             }
   }
char pabaiga=3;     //specialus simbolis, zymesiantis pabaiga (sirdute :)) )
if (send(soketas, &pabaiga, 1, 0) != 1)
   {
   cout << "Nepavyko nusiusti duomenu." << endl;
   return 1;
   }
return 0;
}


int itraukti_uzrasa(SOCKET soketas, knygute* &knygele)  //funkcija, kuri itraukia nauja uzrasa i knygute
{
char uzrasas[256];
if (recv(soketas, uzrasas, 256, 0)!=256)   //gauname duomenis, panasiai kaip siunciame su send
      {  //((soketas, i kur saugome, kiek simboliu parsisiusime, nezinau) != simboliu kiekis)
      cout << "Nepavyko gauti duomenu." << endl;
      return 1;
      }  
knygute* knygele2;         //dinaminio saraso dalykai...
knygele2=knygele;
while (knygele2->kitas!=NULL)
      knygele2=knygele2->kitas;
knygele2->kitas=new knygute;
knygele2->kitas->kitas=NULL;
strcpy(knygele2->kitas->uzrasas,uzrasas);   //naudoju strcpy, nes su char masyvais dirbam
return 0;
}


int istrinti_uzrasa(SOCKET soketas, knygute* &knygele)     //istrina uzrasa is knygutes
{
char nr[6];             //cia parsisiusime numeri trinamo uzraso
if (recv(soketas, nr, 6, 0)!=6)
   {
   cout << "Nepavyko gauti duomenu." << endl;
   return 1;
   }
int numeris=atoi(nr), i;       //paverciame is char i int
char klaida=3;        //specialus klaidos simbolis
knygute* knygele2;

for (i=0, knygele2=knygele; i<numeris-1; i++)
    if (knygele2->kitas != NULL) 
       knygele2=knygele2->kitas;
       else 
            {
            if (send(soketas, &klaida, 1, 0) != 1)
               {
               cout << "Nepavyko nusiusti duomenu." << endl;
               return 1;
               }
            return 0;
            }
if (knygele2->kitas != NULL)
   {
   if (send(soketas, knygele2->kitas->uzrasas, 256, 0) != 256)
      {
      cout << "Nepavyko nusiusti duomenu." << endl;
      return 1;
      }
   knygele2->kitas=knygele2->kitas->kitas;
   return 0;
   }
   else
       {
       if (send(soketas, &klaida, 1, 0) != 1)
          {
          cout << "Nepavyko nusiusti duomenu." << endl;
          return 1;
          }
       return 0;
       }
}


int meniu (SOCKET soketas, knygute* &knygele)  //operaciju su uzrasu knygute meniu
{
char pasirinkimas='0';
while (pasirinkimas != '4')
      {
      if (recv(soketas, &pasirinkimas, 1, 0)!=1)
         {
         cout << "Nepavyko gauti duomenu." << endl;
         return 1;
         }
      switch(pasirinkimas)
             {
             case '1' : if (perziureti(soketas, knygele) == 1)  //cia tikrinam ar neivyko klaida funkcijoje
                           return 1; 
                        break;
             case '2' : if (itraukti_uzrasa(soketas, knygele) ==1)
                           return 1;
                        break;
             case '3' : if (istrinti_uzrasa(soketas, knygele) ==1)
                           return 1;
                        break;
             default : break;
             }
      }
return 0;
}


int nauja_knygute (SOCKET soketas, vector<knygute*> &knygutes)   //jeigu reikia sukurti nauja knygute
{ 
char pranesimas[256];
knygute* knygele=new knygute;
knygele->kitas=NULL;
if (recv(soketas, pranesimas, 256, 0)!=256)
   {
   cout << "Nepavyko gauti duomenu." << endl;
   return 1;
   }    
strcpy(knygele->uzrasas,pranesimas);
knygutes.push_back(knygele);   //i vektoriu idedam nauja elementa

char numeris[6];
itoa(knygutes.size()-1, numeris, 10);  //paverciam int i char (int reiksme, char i kuri uzsaugom, skaiciu sistema)
if (send(soketas, numeris, 6, 0) != 6)
   {
   cout << "Nepavyko nusiusti duomenu." << endl;
   return 1;
   }  
if (meniu(soketas, knygutes.back())==1)  //kreipiames i meniu su paskutiniu (naujausiu) vektoriaus elementu
   return 1;
   else return 0; 
}


int turi_knygute (SOCKET soketas, vector<knygute*> &knygutes)  //jeigu reikia atverti jau egzistuojancia uzrasu knygute
{
char nr[6], pranesimas[256];
if (recv(soketas, nr, 6, 0)!=6)   //gaunam knygutes numeri
   {
   cout << "Nepavyko gauti duomenu." << endl;
   return 1;
   }
int numeris=atoi(nr);
if ((numeris < 0) || (numeris>knygutes.size()-1)) //tikrinam ar gera numeri gavom
   pranesimas[0] = 'n';     //jeigu kazkas nurodyta neteisingai, tai siunciam n
   else pranesimas[0] = 't';  //kitu atveju t
if (send(soketas, pranesimas, 1, 0) != 1)
   {
   cout << "Nepavyko nusiusti duomenu." << endl;
   return 1;
   }
if (pranesimas[0]=='n')
   return 0;
if (recv(soketas, pranesimas, 256, 0)!=256)     //gaunam knygutes slaptazodi
   {
   cout << "Nepavyko gauti duomenu." << endl;
   return 1;
   }    
if (strcmp(pranesimas, knygutes[numeris]->uzrasas)==0)  //naudoju strcmp, nes su char masyvais dirbam
   pranesimas[0] = 't';
   else pranesimas[0] = 'n';
if (send(soketas, pranesimas, 1, 0) != 1)
   {
   cout << "Nepavyko nusiusti duomenu." << endl;
   return 1;
   }             
if (pranesimas[0] == 't')   
   if (meniu(soketas, knygutes[numeris]) ==1)
      return 1;
return 0;
}


int knyguciu_meniu (SOCKET soketas, vector<knygute*> &knygutes)   //meniu, kai vartotojas renkasi, ar turi knygute, ar susikurti nauja
{
char pasirinkimas;
if (recv(soketas, &pasirinkimas, 1, 0)!=1)
   {
   cout << "Nepavyko gauti duomenu." << endl;
   return 1;
   }
if (pasirinkimas == '2')
   {
   if (nauja_knygute(soketas, knygutes)==1)
      return 1;
   }
   else
   {
   if (turi_knygute(soketas, knygutes)==1)
      return 1;
   }
return 0;
}


int main()
{
vector<knygute*> knygutes;
WSADATA wsaData;             
if (WSAStartup(MAKEWORD(2,0), &wsaData) != 0)  //leidziam WSA
   {
   cout << "Nepavyko paleisti WSAStartup()" ;
   exit(1);
   }
cout << "Iveskite kuri porta naudos serveris" << endl;
short portas;        //porto reiksme turi buti short tipo
cin >> portas;

SOCKET soketas = socket(AF_INET, SOCK_STREAM, 0); //1-over tcp/ip  2-stream orentied socket
if (soketas == INVALID_SOCKET)   //bandom kurt soketa
   {
   cout << "Klaida sukuriant soketa." << endl;
   exit(1);
   }

struct sockaddr_in serveris;        //neisivaizduoju kas cia per strukturos
serveris.sin_family = AF_INET;      //protokolo tipas  (af_inet=tcp/ip)     
serveris.sin_port = htons(portas);  // port number  of socket    
serveris.sin_addr.s_addr = INADDR_ANY;  //ip address
memset(&(serveris.sin_zero), '\0', 8);   
if (bind(soketas, (struct sockaddr *)&serveris, sizeof(struct sockaddr)) == -1) //surisam socketa su serverio adresu
   {
   cout << "Klaida bandant susieti soketa su portu." << endl;
   exit(1);
   }

listen(soketas, 10);  //lauksim signalu / iki 10 sujungimu priimti
SOCKET soketas2;
char pranesimas[256];
while(true)  //amzinas ciklas
     {
     cout << "Laukiama kliento." << endl;  
     soketas2 = accept(soketas, NULL, NULL);  //priimam signala / 1-adreasa sockadr_in stukturos  2-kintamojo adresas 3-strukturos dydis
     if(soketas2 == INVALID_SOCKET) 
        {
        cout << "Nepavyko prijungti kliento." << endl;
        exit(1);
		}
     cout << "Klientas prijungtas sekmingai." << endl;
     if (knyguciu_meniu(soketas2, knygutes)==1)   //pradedam visa dziaugsma
        cout << "Nutruko rysys su klientu." << endl;
        else cout << "Klientas aptarnautas sekmingai." << endl;
     closesocket(soketas2);   //uzdarau, nes tingejau aiskintis kaip tiksliai daryt, kad ir klientas ir serveris galetu suktis amzinai while cikle
     }                        //o taip gaunasi, kad leidzia tam paciam klientui dar karta prisijungt, gali but ir visai nereikalinga :))
}
